qpid::client::QueueOptions Class Reference

Apache Qpid - AMQP Messaging for Java JMS, C++, Python, Ruby, and .NET | Apache Qpid Documentation

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Attributes
qpid::client::QueueOptions Class Reference

A help class to set options on the Queue. More...

`#include <qpid/client/QueueOptions.h>`

List of all members.

## Public Types
typedef boost::shared_ptr < FieldValue > | ValuePtr
typedef std::map< std::string, ValuePtr > | ValueMap
typedef ValueMap::iterator | iterator
typedef ValueMap::const_iterator | const_iterator
typedef ValueMap::const_reference | const_reference
typedef ValueMap::reference | reference
typedef ValueMap::value_type | value_type
## Public Member Functions
| QueueOptions ()
virtual | ~QueueOptions ()
void | setSizePolicy (QueueSizePolicy sp, uint64_t maxSize, uint32_t maxCount)
| Sets the queue sizing policy.
void | setPersistLastNode ()
| Enables the persisting of a queue to the store module when a cluster fails down to it's last node.
void | setOrdering (QueueOrderingPolicy op)
| Sets the odering policy on the Queue, default ordering is FIFO.
void | clearSizePolicy ()
| Use broker defualt sizing ploicy.
void | clearPersistLastNode ()
| Clear Persist Last Node Policy.
void | getLVQKey (std::string &key)
| get the key used match LVQ in args for message transfer
void | clearOrdering ()
| Use default odering policy.
void | enableQueueEvents (bool enqueueOnly)
| Turns on event generation for this queue (either enqueue only or for enqueue and dequeue events); the events can then be processed by a regsitered broker plugin.
uint32_t | encodedSize () const
void | encode (Buffer &buffer) const
void | decode (Buffer &buffer)
int | count () const
QPID_COMMON_INLINE_EXTERN size_t | size () const
QPID_COMMON_INLINE_EXTERN bool | empty ()
void | set (const std::string &name, const ValuePtr &value)
ValuePtr | get (const std::string &name) const
QPID_COMMON_INLINE_EXTERN bool | isSet (const std::string &name) const
void | setString (const std::string &name, const std::string &value)
void | setInt (const std::string &name, const int value)
void | setInt64 (const std::string &name, const int64_t value)
void | setTimestamp (const std::string &name, const uint64_t value)
void | setUInt64 (const std::string &name, const uint64_t value)
void | setTable (const std::string &name, const FieldTable &value)
void | setArray (const std::string &name, const Array &value)
void | setFloat (const std::string &name, const float value)
void | setDouble (const std::string &name, const double value)
int | getAsInt (const std::string &name) const
uint64_t | getAsUInt64 (const std::string &name) const
int64_t | getAsInt64 (const std::string &name) const
std::string | getAsString (const std::string &name) const
bool | getTable (const std::string &name, FieldTable &value) const
bool | getArray (const std::string &name, Array &value) const
bool | getFloat (const std::string &name, float &value) const
bool | getDouble (const std::string &name, double &value) const
void | erase (const std::string &name)
bool | operator== (const FieldTable &other) const
ValueMap::const_iterator | begin () const
ValueMap::iterator | begin ()
ValueMap::const_iterator | end () const
ValueMap::iterator | end ()
ValueMap::const_iterator | find (const std::string &s) const
ValueMap::iterator | find (const std::string &s)
std::pair< ValueMap::iterator, bool > | insert (const ValueMap::value_type &)
ValueMap::iterator | insert (ValueMap::iterator, const ValueMap::value_type &)
void | clear ()
## Static Public Attributes
static const std::string | strMaxCountKey
static const std::string | strMaxSizeKey
static const std::string | strTypeKey
static const std::string | strREJECT
static const std::string | strFLOW_TO_DISK
static const std::string | strRING
static const std::string | strRING_STRICT
static const std::string | strLastValueQueue
static const std::string | strPersistLastNode
static const std::string | strLVQMatchProperty
static const std::string | strLastValueQueueNoBrowse
static const std::string | strQueueEventMode

## Detailed Description

A help class to set options on the Queue.

Create a configured args while still allowing any custom configuration via the FieldTable base class

## Member Typedef Documentation

typedef ValueMap::const_iterator qpid::framing::FieldTable::const_iterator`[inherited]`

Definition at line 59 of file FieldTable.h.

typedef ValueMap::const_reference qpid::framing::FieldTable::const_reference`[inherited]`

Definition at line 60 of file FieldTable.h.

typedef ValueMap::iterator qpid::framing::FieldTable::iterator`[inherited]`

Definition at line 58 of file FieldTable.h.

typedef ValueMap::reference qpid::framing::FieldTable::reference`[inherited]`

Definition at line 61 of file FieldTable.h.

typedef ValueMap::value_type qpid::framing::FieldTable::value_type`[inherited]`

Definition at line 62 of file FieldTable.h.

typedef std::map<std::string, ValuePtr> qpid::framing::FieldTable::ValueMap`[inherited]`

Definition at line 57 of file FieldTable.h.

typedef boost::shared_ptr<FieldValue> qpid::framing::FieldTable::ValuePtr`[inherited]`

Definition at line 56 of file FieldTable.h.

## Constructor & Destructor Documentation

qpid::client::QueueOptions::QueueOptions | ( |  | ) |

virtual qpid::client::QueueOptions::~QueueOptions | ( |  | ) | `[virtual]`

## Member Function Documentation

ValueMap::const_iterator qpid::framing::FieldTable::begin | ( |  | ) | const`[inherited]`

ValueMap::iterator qpid::framing::FieldTable::begin | ( |  | ) | `[inherited]`

void qpid::framing::FieldTable::clear | ( |  | ) | `[inherited]`

void qpid::client::QueueOptions::clearOrdering | ( |  | ) |

Use default odering policy.

void qpid::client::QueueOptions::clearPersistLastNode | ( |  | ) |

Clear Persist Last Node Policy.

void qpid::client::QueueOptions::clearSizePolicy | ( |  | ) |

Use broker defualt sizing ploicy.

int qpid::framing::FieldTable::count | ( |  | ) | const`[inherited]`

void qpid::framing::FieldTable::decode | ( | Buffer & | buffer | ) | `[inherited]`

QPID_COMMON_INLINE_EXTERN bool qpid::framing::FieldTable::empty | ( |  | ) | `[inline, inherited]`

Definition at line 74 of file FieldTable.h.

References qpid::framing::FieldTable::size().

void qpid::client::QueueOptions::enableQueueEvents | ( | bool | enqueueOnly | ) |

Turns on event generation for this queue (either enqueue only or for enqueue and dequeue events); the events can then be processed by a regsitered broker plugin.

DEPRECATED

This is confusing to anyone who sees only the function call and not the variable name / doxygen. Consider the following call:

options.enableQueueEvents(false);

It looks like it disables queue events, but what it really does is enable both enqueue and dequeue events.

Use setInt() instead:

options.setInt("qpid.queue_event_generation", 2);

void qpid::framing::FieldTable::encode | ( | Buffer & | buffer | ) | const`[inherited]`

uint32_t qpid::framing::FieldTable::encodedSize | ( |  | ) | const`[inherited]`

ValueMap::const_iterator qpid::framing::FieldTable::end | ( |  | ) | const`[inherited]`

ValueMap::iterator qpid::framing::FieldTable::end | ( |  | ) | `[inherited]`

void qpid::framing::FieldTable::erase | ( | const std::string & | name | ) | `[inherited]`

ValueMap::const_iterator qpid::framing::FieldTable::find | ( | const std::string & | s | ) | const`[inherited]`

ValueMap::iterator qpid::framing::FieldTable::find | ( | const std::string & | s | ) | `[inherited]`

ValuePtr qpid::framing::FieldTable::get | ( | const std::string & | name | ) | const`[inherited]`

bool qpid::framing::FieldTable::getArray | ( | const std::string & | name,
|  | Array & | value
| ) |  | const`[inherited]`

int qpid::framing::FieldTable::getAsInt | ( | const std::string & | name | ) | const`[inherited]`

int64_t qpid::framing::FieldTable::getAsInt64 | ( | const std::string & | name | ) | const`[inherited]`

std::string qpid::framing::FieldTable::getAsString | ( | const std::string & | name | ) | const`[inherited]`

uint64_t qpid::framing::FieldTable::getAsUInt64 | ( | const std::string & | name | ) | const`[inherited]`

bool qpid::framing::FieldTable::getDouble | ( | const std::string & | name,
|  | double & | value
| ) |  | const`[inherited]`

bool qpid::framing::FieldTable::getFloat | ( | const std::string & | name,
|  | float & | value
| ) |  | const`[inherited]`

void qpid::client::QueueOptions::getLVQKey | ( | std::string & | key | ) |

get the key used match LVQ in args for message transfer

bool qpid::framing::FieldTable::getTable | ( | const std::string & | name,
|  | FieldTable & | value
| ) |  | const`[inherited]`

std::pair<ValueMap::iterator, bool> qpid::framing::FieldTable::insert | ( | const ValueMap::value_type & |  | ) | `[inherited]`

ValueMap::iterator qpid::framing::FieldTable::insert | ( | ValueMap::iterator | ,
|  | const ValueMap::value_type & |
| ) |  | `[inherited]`

QPID_COMMON_INLINE_EXTERN bool qpid::framing::FieldTable::isSet | ( | const std::string & | name | ) | const`[inline, inherited]`

Definition at line 77 of file FieldTable.h.

bool qpid::framing::FieldTable::operator== | ( | const FieldTable & | other | ) | const`[inherited]`

void qpid::framing::FieldTable::set | ( | const std::string & | name,
|  | const ValuePtr & | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setArray | ( | const std::string & | name,
|  | const Array & | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setDouble | ( | const std::string & | name,
|  | const double | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setFloat | ( | const std::string & | name,
|  | const float | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setInt | ( | const std::string & | name,
|  | const int | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setInt64 | ( | const std::string & | name,
|  | const int64_t | value
| ) |  | `[inherited]`

void qpid::client::QueueOptions::setOrdering | ( | QueueOrderingPolicy | op | ) |

Sets the odering policy on the Queue, default ordering is FIFO.

void qpid::client::QueueOptions::setPersistLastNode | ( |  | ) |

Enables the persisting of a queue to the store module when a cluster fails down to it's last node.

Does so optimistically. Will start persisting when cluster count >1 again.

void qpid::client::QueueOptions::setSizePolicy | ( | QueueSizePolicy | sp,
|  | uint64_t | maxSize,
|  | uint32_t | maxCount
| ) |  |

Sets the queue sizing policy.

Parameters:

  sp | SizePolicy REJECT - reject if queue greater than size/count FLOW_TO_DISK - page messages to disk from this point is greater than size/count RING - limit the queue to size/count and over-write old messages round a ring RING_STRICT - limit the queue to size/count and reject is head == tail NONE - Use default broker sizing policy
  maxSize | Set the max number of bytes for the sizing policies
  setMaxCount | Set the max number of messages for the sizing policies

void qpid::framing::FieldTable::setString | ( | const std::string & | name,
|  | const std::string & | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setTable | ( | const std::string & | name,
|  | const FieldTable & | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setTimestamp | ( | const std::string & | name,
|  | const uint64_t | value
| ) |  | `[inherited]`

void qpid::framing::FieldTable::setUInt64 | ( | const std::string & | name,
|  | const uint64_t | value
| ) |  | `[inherited]`

QPID_COMMON_INLINE_EXTERN size_t qpid::framing::FieldTable::size | ( |  | ) | const`[inline, inherited]`

Definition at line 73 of file FieldTable.h.

Referenced by qpid::framing::FieldTable::empty().

## Member Data Documentation

const std::string qpid::client::QueueOptions::strFLOW_TO_DISK`[static]`

Definition at line 115 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strLastValueQueue`[static]`

Definition at line 118 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strLastValueQueueNoBrowse`[static]`

Definition at line 121 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strLVQMatchProperty`[static]`

Definition at line 120 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strMaxCountKey`[static]`

Definition at line 111 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strMaxSizeKey`[static]`

Definition at line 112 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strPersistLastNode`[static]`

Definition at line 119 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strQueueEventMode`[static]`

Definition at line 122 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strREJECT`[static]`

Definition at line 114 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strRING`[static]`

Definition at line 116 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strRING_STRICT`[static]`

Definition at line 117 of file QueueOptions.h.

const std::string qpid::client::QueueOptions::strTypeKey`[static]`

Definition at line 113 of file QueueOptions.h.

The documentation for this class was generated from the following file:

- qpid/client/QueueOptions.h